#include "Syslog.h"

TSyslog::TSyslog(BLooper *Target,BMessage *Message,unsigned int port):BLooper("SyslogLooper")
{
BMessage StartMsg('stat');

  if ( Target == NULL ) {
    MessageTarget = be_app;
  } else {
    MessageTarget = Target;
  };
  InfoMessage = Message;
  InfoMessage->AddString("log","dummy");

  SyslogEndpoint.SetProtocol(SOCK_DGRAM);
  SyslogEndpoint.Bind(port);
  SyslogEndpoint.SetNonBlocking(false);
  SyslogEndpoint.SetTimeout(100000);

  this->Run();
  this->PostMessage(&StartMsg);
}

TSyslog::~TSyslog()
{
  delete InfoMessage;
}

void TSyslog::MessageReceived(BMessage *msg)
{
  switch( msg->what ) {
    case 'stat':
      Receiving();
    break;
  };
}

void TSyslog::Receiving()
{
int loglen,i;
char buf[1500];
BNetAddress DummyAddress;

  loop = true;
  while ( loop==true ) {
    loglen = SyslogEndpoint.ReceiveFrom(buf,1500,DummyAddress,0);
    if (loglen > 0) {
      for (i=0;i<loglen;i++) {
        if ( buf[i]<32 ) {
          buf[i] = 32;
        };
      };
    buf[loglen] = 0;
    InfoMessage->ReplaceString("log",buf);
    MessageTarget->PostMessage(InfoMessage);
    };
  };
}
