#include "SNGView.h"

TSyslogView::TSyslogView( BRect frame ):BView( frame, "SyslogView",B_FOLLOW_ALL,B_WILL_DRAW)
{
BRect LogFrame,scrollbarFrameV,scrollbarFrameH;

  scrollbarFrameV = frame;
  scrollbarFrameV.OffsetTo(B_ORIGIN);
  scrollbarFrameV.left = 1 + scrollbarFrameV.right - B_V_SCROLL_BAR_WIDTH;
  scrollbarFrameV.bottom -= B_H_SCROLL_BAR_HEIGHT;
  scrollbarFrameH = frame;
  scrollbarFrameH.OffsetTo(B_ORIGIN);
  scrollbarFrameH.right -= B_V_SCROLL_BAR_WIDTH;
  scrollbarFrameH.top = 1 + scrollbarFrameH.bottom - B_H_SCROLL_BAR_HEIGHT;

  LogFrame = frame;
  LogFrame.OffsetTo(B_ORIGIN);
  LogFrame.top = 0;
  LogFrame.left = 0;
  LogFrame.bottom -= B_H_SCROLL_BAR_HEIGHT;
  LogFrame.right -= B_V_SCROLL_BAR_WIDTH;

  LogTextView = new BTextView( LogFrame, "logtextview", LogFrame, B_FOLLOW_ALL, B_WILL_DRAW );
  AddChild( LogTextView );
  LogTextView->MakeResizable( true ,NULL );
  LogTextView->MakeEditable( false );

  scrollBarV = new BScrollBar( scrollbarFrameV, "scrollbarv", (BView *)LogTextView, 0, 800-LogFrame.Height() , B_VERTICAL );
  AddChild( scrollBarV );
  scrollBarH = new BScrollBar( scrollbarFrameH, "scrollbarh", (BView *)LogTextView, 0, 800-LogFrame.Width() , B_HORIZONTAL );
  AddChild( scrollBarH );

}
